import os
from Extracter import DoxygenXMLExtractor
from Metrics import *

class CSV:
	
	# DSC NOH ANA DAM DCC CAM MOA MFA NOP CIS NOM
	fileName = 'CurrentOutput.csv'
	path = ''
	metricList = {}
	proList = []
	nop= NOP_C_Metric # mean
	moa = MOA_C_Metric
	cis = CIS_C_Metric
	nom = NOM_C_Metric
	dam = DAM_C_Metric
	dcc = DCC_C_Metric
	cam = CAM_C_Metric
	mfa = MFA_C_Metric
	
	dsc = DSC_C_Metric # sum
	
	noh = NOH_P_Metric # raw
	ana = ANA_P_Metric
	
	meanDic = {}
	meanDic['NOP'], meanDic['MOA'], meanDic['CIS'], meanDic['NOM'], meanDic['DAM'], meanDic['DCC'], meanDic['CAM'], meanDic['MFA'] = nop, moa, cis, nom, dam, dcc, cam, mfa
	sumDic = {}
	sumDic['DSC'] = dsc
	rawDic = {}
	rawDic['NOH'], rawDic['ANA'] = noh, ana
	
	def __init__(self, outputFN):
		self.proList = self.extractor()	
		self.fileName = outputFN
	
	def all_paths(self,projPath = ""):
		path = ''
		pathList = []
		listAllFilenames = os.listdir(projPath+'projects')
		print 'projects:', listAllFilenames
		for dir in listAllFilenames:
			pathList.append('projects/'+dir + '/xml')
			#self.path = dir
		return pathList

	def all_dir_paths(self,projPath = ""):
		path = ''
		pathList = []
		for anypath in self.all_paths(projPath):
			if os.path.isdir(anypath):
				pathList.append(anypath)
		return pathList
	
	
	def extractor(self):
		pro_pathList = self.all_dir_paths()
		proList = {}
		for path in pro_pathList:
			# [seLain] path.split['/'][-1] is project directory name, wich is usually project name with version
			projectName = '-'.join(path.split('/')[-2].split('-')[0:2])
			print projectName, '------- extracting'
			ext = DoxygenXMLExtractor()
			proList[projectName]  = (ext.extract_proj(path))
			print projectName, '------- extracted'
		return proList	


	def writeNewFile(self ):
		f = open(self.fileName, 'w')
		f.write("project name\\metric name ")
		
		## [seLain] write column item names ?
		# p = self.proList[self.path]
		p = self.proList[self.proList.keys()[0]]
		pcsv = ProjectCSV(self.path,p, self.meanDic,self.sumDic,self.rawDic)
		dict = pcsv.getDict()
		for metric in dict.keys():
			f.write("," + metric)
		f.write("\n")
			
		for project in self.proList.keys():
			p = self.proList[project]
			pcsv = ProjectCSV(project,p, self.meanDic,self.sumDic,self.rawDic)
			dict = pcsv.getDict()
			f.write(project)
			for metric in dict.keys():
				f.write("," )
				f.write(dict[metric].__str__())
			f.write("\n")
		f.close()
		
		return self.fileName
	
	
	
class ProjectCSV:
	
	projectName = ''
	metricsValue = {}
	metricList = []
	classList = []
	
	nop = NOP_C_Metric # mean
	moa = MOA_C_Metric
	cis = CIS_C_Metric
	nom = NOM_C_Metric
	dam = DAM_C_Metric
	dcc = DCC_C_Metric
	cam = CAM_C_Metric
	mfa = MFA_C_Metric
	meanList = [nop, moa, cis, nom, dam, dcc, cam, mfa]
	meanDic = {}
	#meanDic['nop'], meanDic['moa'], meanDic['cis'], meanDic['nom'], meanDic['dam'], meanDic['dcc'], meanDic['cam'], meanDic['mfa'] = nop, moa, cis, nom, dam, dcc, cam, mfa
	
	dsc = DSC_C_Metric # sum
	sumList = [dsc]
	sumDic = {}
	#sumDic['dsc'] = dsc
	
	noh = NOH_P_Metric # raw
	ana = ANA_P_Metric
	rawList = [noh, ana]
	rawDic = {}
	#rawDic['noh'], rawDic['ana'] = noh, ana
	
	
	def __init__(self, pN , pO, mm, ss, rr):
		self.projectName = pN
		self.projObj = pO
		self.meanDic = mm
		self.sumDic = ss
		self.rawDic = rr
	
	
	def getSum(self,pro):
		sumDict = {}
		
		for metric in self.sumDic.keys():
			temp = Sum(pro, self.sumDic[metric])
			sumDict[metric] = temp['sum']
		return sumDict

	def getRaw(self,pro):
		rawDict = {}
		
		for metric in self.rawDic.keys():
			temp = self.rawDic[metric](pro)
			rawDict[metric] = temp
		return rawDict
		


	def getMean(self,pro):
		meanDict = {}
		
		for metric in self.meanDic.keys():
			temp = Mean(pro, self.meanDic[metric])
			meanDict[metric] =  temp['average']
		return meanDict
		
	def getDict(self):
		self.metricsValue = {}
		m = self.getMean(self.projObj)
		r = self.getRaw(self.projObj)
		s = self.getSum(self.projObj)
		
		for key in m.keys():
			self.metricsValue[key] = m[key]
		for key in r.keys():
			self.metricsValue[key] = r[key]
		for key in s.keys():
			self.metricsValue[key] = s[key]
			
		return self.metricsValue
		
	
	
		
		
		
		
	

	